#include "Obelisk.h"

#include "CBlade.h"
#include "CMap.h"
#include "CKnifeBot.h"

using namespace std;
using namespace Obelisk;



CBlade::CBlade(CMap* aMap, int aX, int aY, float aAngle)
{
	mMap = aMap;
	mX = aX;
	mY = aY;
	mAngle = aAngle;

	mAttached = false;
	mKnifeBot = NULL;

	mGeneration = -1;
}



void CBlade::SetAttached(CKnifeBot* aKnifeBot, bool aAttached)
{
	Assert(!aAttached || aKnifeBot != NULL)
	mKnifeBot = aKnifeBot;
	mAttached = aAttached;
}



void CBlade::Move(int aX, int aY, float aAngle)
{
	mX = aX;
	mY = aY;
	mAngle = aAngle;
}



void CBlade::Launch(IObelisk* aObelisk)
{
	Assert(mKnifeBot != NULL && mAttached)
	mKnifeBot->DetachBlade(this);
	mAttached = false;
	int Angle = aObelisk->Random(0, 359);
	int Velocity = aObelisk->Random(20, 35);
	mVelocity = pair<float, float>(Angle, Velocity);
	mRealPos = pair<float, float>(mX, mY);
}



void CBlade::LaunchAngle(IObelisk* aObelisk, float aAngle)
{
	Assert(mKnifeBot != NULL)
	if (mAttached)
		mKnifeBot->DetachBlade(this);
	mAttached = false;
	int Velocity = aObelisk->Random(27, 39);
	mVelocity = pair<float, float>(aAngle, Velocity);
	mRealPos = pair<float, float>(mX, mY);
}



void CBlade::Step()
{
	if (mKnifeBot != NULL && !mAttached)
	{
		double Rainbow = mVelocity.first * M_PI / 180;
		mRealPos.first += cos(Rainbow) * mVelocity.second;
		mRealPos.second += sin(Rainbow) * mVelocity.second;
		mVelocity.second *= .961;
		if (mVelocity.second < 5)
		{
			mKnifeBot = NULL;
			mGeneration = -1;
		}
		if (mRealPos.first < 0 && mVelocity.first >= 90 && mVelocity.first <= 270)
		{
			mRealPos.first = -mRealPos.first;
			mVelocity.first = 180 - mVelocity.first;
			if (mVelocity.first < 0)
				mVelocity.first += 360;
		}
		if (mRealPos.first >= mMap->GetXSize() && (mVelocity.first >= 270 || mVelocity.first <= 90))
		{
			mRealPos.first = mMap->GetXSize() - (mRealPos.first - mMap->GetXSize());
			mVelocity.first = 180 - mVelocity.first;
			if (mVelocity.first < 0)
				mVelocity.first += 360;
		}
		if (mRealPos.second < 0 && mVelocity.first >= 180)
		{
			mRealPos.second = -mRealPos.second;
			mVelocity.first = 360 - mVelocity.first;
		}
		if (mRealPos.second >= mMap->GetYSize() && mVelocity.first <= 180)
		{
			mRealPos.second = mMap->GetYSize() - (mRealPos.second - mMap->GetYSize());
			mVelocity.first = 360 - mVelocity.first;
		}
		mX = mRealPos.first;
		mY = mRealPos.second;
	}
}