#include "Obelisk.h"

#include "CKnifeBot.h"
#include "CMap.h"
#include "CBlade.h"

using namespace std;
using namespace Obelisk;



CKnifeBot::CKnifeBot(CMap* aMap, int aX, int aY, int aDir, bool aOrientation)
{
	mMap = aMap;
	mX = aX * 36 + 18;
	mY = aY * 36 + 18;
	mDir = aDir;

	mAngle = mDir * 90;
	mOrientation = aOrientation;
	mMode = 1;
	mSteps = 18;

	mBladeAngle = 0;
}



void CKnifeBot::Step(IObelisk* aObelisk)
{
	if (mMode == 0)
	{
		bool Move = true;
		if (mX % 36 == 18 && mY % 36 == 18)
		{
			bool EdgeOfMap;
			switch (mDir)
			{
				case 0:
					EdgeOfMap = (mX - 18) / 36 == mMap->GetGridXSize() - 1;
					break;
				case 1:
					EdgeOfMap = (mY - 18) / 36 == mMap->GetGridYSize() - 1;
					break;
				case 2:
					EdgeOfMap = mX - 18 == 0;
					break;
				case 3:
					EdgeOfMap = mY - 18 == 0;
					break;
			}
			if (--mSteps == 0 || EdgeOfMap)
			{
				mMode = 1;
				mSteps = 18;
				Move = false;
			}
		}
		if (Move)
		{
			const int cMove = 3;
			switch (mDir)
			{
				case 0:
					mX += cMove;
					break;
				case 1:
					mY += cMove;
					break;
				case 2:
					mX -= cMove;
					break;
				case 3:
					mY -= cMove;
					break;
			}
		}
	}
	else if (mMode == 1)
	{
		if (--mSteps == 0)
		{
			if (!mOrientation)
				mDir = (mDir + 3) % 4;
			else
				mDir = (mDir + 1) % 4;
			mAngle = mDir * 90;
			mMode = 0;
			mSteps = aObelisk->Random(3, 6);
		}
		else
		{
			const int cRotate = 5;
			if (!mOrientation)
				mAngle += 360 - cRotate;
			else
				mAngle += cRotate;
			if (mAngle >= 360)
				mAngle -= 360;
		}
	}

	if (mBlades.size() != 0)
	{
		const int cRadius = 55;
		mBladeAngle += 9;
		if (mBladeAngle >= 360)
			mBladeAngle -= 360;
		for (int i = 0; i < mBlades.size(); i++)
		{
			float Angle = mBladeAngle + mBlades[i]->GetOffset();
			mBlades[i]->Move(mX + cos(Angle * M_PI / 180) * cRadius,
					mY + sin(Angle * M_PI / 180) * cRadius, Angle);
		}
	}
}



bool CKnifeBot::IsAttached(CBlade* aBlade)
{
	for (int i = 0; i < mBlades.size(); i++)
	{
		if (mBlades[i] == aBlade)
			return true;
	}
	return false;
}



void CKnifeBot::AttachBlade(IObelisk* aObelisk, CBlade* aBlade)
{
	mBlades.push_back(aBlade);
	aBlade->SetAttached(this, true);
	if (mBlades.size() == 1)
		mBladeAngle = aObelisk->Random(0, 359);
	else
	{
		for (int i = 0; i < mBlades.size(); i++)
			mBlades[i]->SetOffset((float)360 / mBlades.size() * i);
	}
}



void CKnifeBot::DetachBlade(CBlade* aBlade)
{
	for (vector<CBlade*>::iterator i = mBlades.begin(); i != mBlades.end(); i++)
	{
		if (*i == aBlade)
		{
			mBlades.erase(i);
			// TODO: readjust blade angles?
			return;
		}
	}
	Assert(false)
}